package loadtests.recording;

import static com.loadcoder.statics.Statics.SECOND;
import java.util.Arrays;
import com.loadcoder.cluster.clients.influxdb.InfluxDBClient;
import com.loadcoder.load.chart.logic.RuntimeChart;
import com.loadcoder.network.LoadcoderGeneratorBuilder;

public class LoadcoderGenerator {

  public static void main(String[] args) {

      new LoadcoderGeneratorBuilder(
          "./petclinic.har",
          Arrays.asList("http://localhost"),
          "loadtests.recording.petclinic2", 
          "src/main/java/loadtests/recording/petclinic", 
          "src/main/resources/generated-resources" 
          )
          .load(120 * SECOND, 3, 5)
          .sendResultTo(RuntimeChart.chartReporter())
          .checkResponseBodiesContaining(Arrays.asList("Pet Clinic"))
          .generate();
      
  }
}