package loadtests.examples.loadcoder.bestpractise;

import org.springframework.web.client.RestTemplate;

import com.loadcoder.load.scenario.Scenario;
import com.loadcoder.load.scenario.design.TypeInstanceBase;

public class ThreadInstance extends TypeInstanceBase {

	final RestTemplate restTemplate;
	final GreetingsLogic greetingsLogic;
	final CustomerLogic customerLogic;

	public ThreadInstance(Scenario theActualScenario) {
		super(theActualScenario);
		restTemplate = new RestTemplate();
		greetingsLogic = new GreetingsLogic(this);
		customerLogic = new CustomerLogic(this);
	}

	public RestTemplate getRestTemplate() {
		return restTemplate;
	}

	public GreetingsLogic getGreetingsLogic() {
		return greetingsLogic;
	}

	public CustomerLogic getCustomerLogic() {
		return customerLogic;
	}
}
