package loadtests.examples.okhttp;

import java.io.IOException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import org.apache.http.ssl.SSLContextBuilder;
import org.springframework.util.ResourceUtils;

import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

/**
 * Example class for how to use OKHttp library to make http calls
 */
public class OkHttpExamples {

	OkHttpClient client = new OkHttpClient();
	OkHttpClient acceptAllTLS = createClient();

	public static void main(String[] args) {
		OkHttpExamples example = new OkHttpExamples();
		example.runExample();
	}
	
	private void runExample() {
		try {
			
			makeCall();
		}catch(Exception e) {
			throw new RuntimeException(e);
		}
	}
	
	public void makeCall() throws IOException{
		Request req = new Request.Builder().url("https://localhost:8490/customer/get?email=hello")
			.build();
			
		Response resp = acceptAllTLS.newCall(req).execute();
		System.out.println(resp.body().string());
	}
	
	public OkHttpClient createClient() {
		try {
			X509TrustManager manager = getX509TrustManager();
		 SSLContext sslContext = SSLContextBuilder
		 .create()
		 .build();
		 sslContext.init(null, new TrustManager[] { manager }, null);
		 SSLSocketFactory sslSocketFactory = sslContext.getSocketFactory();
		 
		 OkHttpClient client = new OkHttpClient.Builder()
				 .followSslRedirects(false)
				 .followRedirects(false)
				 .sslSocketFactory(sslSocketFactory, manager)
				 .hostnameVerifier((hostname, session)-> { 
					 return true;})
				 .build();
		 return client;
		}catch(Exception e) {
			throw new RuntimeException(e);
		}
	}
	
	private X509TrustManager getX509TrustManager() {
		X509TrustManager manager = new X509TrustManager() {
			
			@Override
			public X509Certificate[] getAcceptedIssuers() {
				X509Certificate[] cArrr = new X509Certificate[0];
                return cArrr;
			}
			
			public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException {}
			public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {}
		};
		return manager;
	}
	
}
