package server.controller;

import java.util.Random;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value = "/api")
public class MyRestController {

	private static final Random random = new Random();

	public MyRestController() {
	}

	@RequestMapping("/greeting")
	public String greeting(@RequestParam(value = "name") String name) {

		sleep(220);
		return String.format("Hello %s", name);
	}

	@RequestMapping("/customer/age")
	public int customerAge(@RequestParam(value = "name") String name) {

		sleep(70);
		int age = random(18, 65);
		return age;
	}

	public void sleep(long millisecondsToSleep) {
		try {
			Thread.sleep(millisecondsToSleep);
		} catch (InterruptedException e) {
			throw new RuntimeException("Could not sleep");
		}
	}

	public static int random(int min, int max) {
		int result = random.nextInt(max - min + 1) + min;
		return result;
	}

}